# -*- coding: utf-8 -*-
"""
/***************************************************************************
 NewObjectDialog
								 A QGIS plugin
 Creates new Object in temp. Shape File
							 -------------------
		begin                : 2015-06-01
		git sha              : $Format:%H$
		copyright            : (C) 2015 by Fugro Consult GmbH
		email                : c.boehnke@fugro.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *
import os, sys, time
from ui_NewObject import Ui_NewObjectDialogBase


class NewObjectDialog(QDockWidget, Ui_NewObjectDialogBase):
	def __init__(self, iface, obj_type_name, alias, project_names, proj_ID):
		# setup UI and connect the buttons
		QDockWidget.__init__(self)
		self.iface = iface
		self.setupUi(self)
		
		self.obj_type_name = obj_type_name
		self.alias = alias
		self.project_names = project_names
		self.proj_ID = proj_ID
		self.display_name = obj_type_name
		
		QObject.connect(self.btn_Shape, SIGNAL("clicked()"), self.createVector)
		
	def createVector(self):

		tmplayer = QgsVectorLayer("Point", self.display_name, "memory")
		
		provider = tmplayer.dataProvider()
	
		# Enter editing mode
		tmplayer.startEditing()

		# add fields to attribute table
		provider.addAttributes([QgsField("ID", QVariant.Int),
								QgsField("XCOORD", QVariant.Double),
								QgsField("YCOORD", QVariant.Double),
								QgsField("PRJNAME", QVariant.String),
								QgsField("OBJECTTYPE", QVariant.String)])
		
		tmplayer.commitChanges()
		
		outName = QFileDialog.getSaveFileName(self, "Save Vector Layer",".", "Shape (*.shp)")
		
		error = QgsVectorFileWriter.writeAsVectorFormat(tmplayer, outName, "CP1250", None, "ESRI Shapefile")
		if error == QgsVectorFileWriter.NoError:
			print "success again!"
		
		self.v_points = QgsVectorLayer(outName, self.display_name, "ogr")
		
		QgsMapLayerRegistry.instance().addMapLayer(self.v_points)
		
		self.v_points.featureAdded.connect(self.NewFeat)	
	
	def NewFeat(self):
		#print "New Feature"
		fcount = self.v_points.featureCount()
		dp = 8
		
		features = self.v_points.getFeatures()
		
		for f in features:
			geom = f.geometry()
			fid = f.id()

			#coords = geom.asPoint()
			#x = coords[0]
			#y = coords[1]
			x = geom.asPoint().x()
			y = geom.asPoint().y()
			
			self.v_points.changeAttributeValue(fid, 1, x)
			self.v_points.changeAttributeValue(fid, 2, y)
			self.v_points.changeAttributeValue(fid, 3, self.project_names)
			self.v_points.changeAttributeValue(fid, 4, self.obj_type_name)